;;; coding: euc-jp
(define (p . tree)
  (html:div :style #`"margin-right: 3px; margin-left: 3px; font-size: 48px; font-family: sans-serif"
            tree))

(define (vs height)
  (html:div :style #`"font-size: 10px; margin-top: ,|height|px" "&nbsp;"))

(define (center . tree)
  (html:div :style "text-align: center" tree))

(define (right . tree)
  (html:div :style "text-align: right" tree))

(define (left . tree)
  (html:div :style "text-align: left" tree))

(define (ptitle . tree)
  (html:div :style "margin: 40px 0px 40px 0px; padding-bottom: 5px; border-bottom-width: 5px; border-bottom-color: #3333ee; border-bottom-style: solid; font-size:54px" tree))

(define (tt . tree)
  (html:div :style "font-family: monospace; font-weight: bold; color: #008800" tree))

(define (pre . tree)
  (html:pre :style "font-family: monospace; font-weight: bold; background-color: #ddeeee; border: solid thin #aacccc; margin-left: 10px" tree))

(define (ul . tree)
  (html:ul :style "margin:5px 0px 5px 0px; padding-right: 30px" tree))

(define (ol . tree)
  (html:ol :style "margin:5px 0px 5px 0px; padding-right: 30px" tree))

(define (li . tree)
  (html:li :style "list-style-type: none" tree))

(define (c1 . tree)
  (html:span :style "color: #aa5500" tree))

(define (c2 . tree)
  (html:span :style "color: #ee0000" tree))

(define (c3 . tree)
  (html:span :style "color: #0044aa" tree))

(define (oshigoto num . tree)
  (center
   (vs 170)
   (d48 #`"LispǤŻ (,num)")
   (vs 80)
   (d48 (html:div :style
                  "color: #0044aa; background-color: #ffdddd;
                   padding: 50px 20px 50px 20px"
                  tree))))
  

(define-macro (make-div-gen size)
  (let ((normal (string->symbol #`"d,|size|"))
        (bold   (string->symbol #`"d,|size|b")))
    `(begin
       (define (,normal . tree)
         (html:div :style
                   (string-append "font-size:" (x->string ,size) "px;")
                   tree))
       (define (,bold . tree)
         (html:div :style
                   (string-append "font-size:" (x->string ,size) "px;"
                                  "font-weight: bold")
                   tree)))))

(make-div-gen 54)
(make-div-gen 48)
(make-div-gen 42)
(make-div-gen 36)
(make-div-gen 28)
(make-div-gen 24)


(define *pages*
  `(,(p (center
         (vs 200)
         (d54 "Kahua Project")
         (vs 20)
         (d48 "Ideas and Early Days")
         (vs 50)
         (d36 " ϯ" (html:br)
              "Scheme Arts, L.L.C.")))
    ,(p (ptitle "طʤȤʤ륢ǥ")
        (c1 "\"Beating the Averages\" (2001)")
        (ul (li "by Paul Graham")
            (li "Webץ˷³Ϥ(CPS)Ѣ"))
        (c1 "\"WASH\" (2003)")
        (ul (li "by Peter Thiemann")
            (li "Web w/³ʥ in Haskell"))
        (c1 "SXML")
        (ul (li "by Oleg Kiselyov et al.")
            (li "ɤȥƥĤͻ")))
    ,(p (ptitle "Event driven")
        (d28 (pre "registration(action, session, data) {
 case action in
  INIT:         show_page1_form(session, nil)
  PAGE1_SUBMIT: if (validate1(data))
                  session[data1] = data
                  show_page2_form(session, nil)
                else
                  show_page1_form(session, data)
  PAGE2_SUBMIT: if (validate2(data))
                  session[data2] = data
                  show_confirm_form(session,
                                    session[data1],
                                    session[data2])
                else
                  show_page2_form(session, data)
  EDIT_AGAIN:   show_page1_form(session, 
                                session[data1])
  CONFIRMED:    update_database(session[data1],
                                session[data2])
}")))
    ,(p (ptitle "³")
        (d28 (pre "registration() {
 do
   do data1 = page1_form()
   until validate(data1)

   do data2 = page2_form()
   until validate(data2)

 until (confirm_form(data1, data2) == CONFIRMED)

 update_database(data1, data2)
}"))
        )
    ,(p (ptitle "³Ѥ/")
        (c1 "")
        (ul (li "־֤ۤݻ")
            (li "̵ꡢʬ˶"))
        (c1 "")
        (ul (li "")
            (li "Ūʸɻߤɬ"))
        )
    ,(p (ptitle "ȯü")
        (c1 "2003ǯ")
        (d36 (ul (li (ul (li "()।󥿡ǥ"
                         (li "Scheme Arts, L.L.C."))))))
        (vs 10)
        (ul (li "ѥץǤη³αѻ")
            (li "Gaucheμ")
            (ul (li "饹")
                (li "³֥"))
            (li "Event driven styleϤ⤦줿"))
        )
    ,(p (ptitle "γȯа")
        (d36
         (c1 "2003/9")
         (ul (li "IPA ץ󥽥եȥѴȡ׺"))
         (c1 "2003/9/")
         (ul (li "1st prototype (kahua-ekahi)"))
         (c1 "2003/11")
         (ul (li "2nd prototype (kahua-elua)"))
         (c1 "2003/12")
         (ul (li "ָ, Kahua 0.1"))
         (c1 "2004/1")
         (ul (li "饹OODB"))
         (c1 "2004/2")
         (ul (li "Kahuaߥʡ")
             (li "ǽ, Kahua 0.2"))
         ))
    ,(p (ptitle "γȯ")
        (d42
         (ul (li "- 饹")
             (li "- դ֥")
             (li "- ʬ³֥")
             (li "- Domain Specific Language")
             (li "- Sand Box 󥿡ץ꥿")
             (li "- DBI")
             (li "- ϥ饤֥ (pdf)")
             (li "- Emacs󥿥ե")
             (li "- cgi-html󥿥ե")
             (li "- ֥ȥեǥ")))
        )
    ,(p (ptitle "")
        (c1 "- Ȥꤢư") (html:br)
        (c1 "- ʥץܤƤߤƸƤ")
        (d42
         (ul (li "OSS Web")
             (d36 (ul (li (tt "http://oss.timedia.co.jp/"))
                      (li "kahuaǥƥĥޥͥ")))
             (li "karetta.jp")
             (d36 (ul (li (tt "http://karetta.jp/"))
                      (li "Web BOOK Portal Site")))
             (li "National Transfer Accounts")
             (d36 (ul (li "Ըǡ١")))
             (li "̼")
             (d36 (ul (li "Хȥå")))
             (li "")))
        )
    ,(p (ptitle "и")
        (c1 "What worked")
        (d42
         (ul (li "SXML˷³³񤯥")
             (ul (li "ȲŬ")))
         (ul (li "kahuaեΥ"(html:br)"ץκΩ夲")
             (ul (li "饤֤Ǥι˰"))))
        )
    ,(p (ptitle "и(2)")
        (c1 "What didn't work")
        (d42
         (ul (li "DSLsand boxĶǤμ¹")
             (ul (li "DSLȯԤ䤬")))
         (ul (li "ȯĶ")
             (ul (li "ȤäƤߤʤȷɤ狼ʤ")
                 (li "ץ곫ȯηиͤɬ")))
         )
        )
    ,(p (ptitle "и(3)")
        (c1 "")
        (d42
         (ul (li "ӥƥ")
             (li "³֥ȥƥ")
             (d36
              (ul (li "ޥƥΰȤꡦӥƥ"
                      "ΥХ󥹤񤷤")))
             (li "ѴĶ(ġ뷲)")))
        )
    ,(p (ptitle "")
        (c1 "褦䤯Kahua1.0")
        (ul (li "- ư΢Ȥ ˤϻ֤")
            (d42
             (ul (li "(̤Υ쥤Τ)")))
            (li "- Ĺ˰ƤƤ椭ޤ礦")
            (li "(ʤߤGauche 1.0Ϥޤޤ)"))
        )
    ))

(set! *title* "Kahua seminar")
