;;; coding: euc-jp
(define (p . tree)
  (html:div :style #`"margin-right: 3px; margin-left: 3px; font-size: 48px; font-family: sans-serif"
            tree))

(define (vs height)
  (html:div :style #`"font-size: 10px; margin-top: ,|height|px" "&nbsp;"))

(define (center . tree)
  (html:div :style "text-align: center" tree))

(define (right . tree)
  (html:div :style "text-align: right" tree))

(define (left . tree)
  (html:div :style "text-align: left" tree))

(define (ptitle . tree)
  (html:div :style "margin: 40px 0px 40px 0px; padding-bottom: 5px; border-bottom-width: 5px; border-bottom-color: #3333ee; border-bottom-style: solid; font-size:54px" tree))

(define (tt . tree)
  (html:div :style "font-family: monospace; font-weight: bold; color: #008800" tree))

(define (pre . tree)
  (html:pre :style "font-family: monospace; font-weight: bold; background-color: #ddeeee; border: solid thin #aacccc; margin-left: 20px" tree))

(define (ul . tree)
  (html:ul :style "margin:5px 0px 5px 0px; padding-right: 30px" tree))

(define (li . tree)
  (html:li :style "list-style-type: none" tree))

(define (c1 . tree)
  (html:span :style "color: #aa5500" tree))

(define (c2 . tree)
  (html:span :style "color: #ee0000" tree))

(define (c3 . tree)
  (html:span :style "color: #0044aa" tree))

(define (oshigoto num . tree)
  (center
   (vs 170)
   (d48 #`"LispǤŻ (,num)")
   (vs 80)
   (d48 (html:div :style
                  "color: #0044aa; background-color: #ffdddd;
                   padding: 50px 20px 50px 20px"
                  tree))))
  

(define-macro (make-div-gen size)
  (let ((normal (string->symbol #`"d,|size|"))
        (bold   (string->symbol #`"d,|size|b")))
    `(begin
       (define (,normal . tree)
         (html:div :style
                   (string-append "font-size:" (x->string ,size) "px;")
                   tree))
       (define (,bold . tree)
         (html:div :style
                   (string-append "font-size:" (x->string ,size) "px;"
                                  "font-weight: bold")
                   tree)))))

(make-div-gen 54)
(make-div-gen 48)
(make-div-gen 42)
(make-div-gen 36)
(make-div-gen 28)
(make-div-gen 24)


(define *pages*
  `(,(p (center
         (vs 200)
         (d54 "Lisp󥵥륿Ȥ")
         (vs 20)
         (d48 "ʪ浡(NIMS)" (html:br)
              "ݡ륵ȹۻ")
         (vs 50)
         (d36 " ϯ" (html:br)
              "Scheme Arts, L.L.C.")))
    ,(p (vs 200)
        (ul (li "- ץȤγ"
                (d36 (ul (li "(ɤƤLispȤץȤǤϤʤ)"))))
            (li "- ץȤηа"
                (d36 (ul (li "(Lispäݤȯв?)"))))))
    ,(p (ptitle "ץȳ")
        (c1 "ȯ")
        (ul (li "ݡ륵(MIPS)"))
        (c1 "ȯ ()")
        (ul (li "2005/112006/02"))
        (c1 "ȯ")
        (ul (li "- () ƥ (MSI)")
            (li "- Scheme Arts, L.L.C.")))
    ,(p (ptitle "ץȳ (cont'd)")
        (c1 "ȯ")
        (ul (li "ݡ륵(MIPS)"))
        (c1 "ȯ ()")
        (ul (li "2005/112006/02"))
        (c1 "ȯ")
        (ul (li "- () ƥ (MSI)")
            (li "- Scheme Arts, L.L.C.")))
    ,(p (ptitle "MIPSץ (cont'd)")
        (c1 "ǽ")
        (ul (li "층 (*)")
            (li (d36 "&nbsp;&nbsp;&nbsp;- ƼDB, blog, wiki, õDB"))
            (li "Ϣ۸")
            (li "ư"))
        (d28 (right "(*) Scheme Artsô"))
        (c1 "ץåȥե")
        (ul (li "- Allegro Common Lisp")
            (li "- AllegroServe")
            (li "- AllegroCache")))
    ,(p (ptitle "층")
        (c1 "󥽡")
        (ul (li "- WebθDB (> 10)")
            (li "- õǡ (local, XML)")
            (li "- ɥ (local, text)"))
        (vs 20)
        "ҤȤĤθǰƤ˸"
        (vs 20)
        "Ϣ۸ɲ"
        (vs 20)
        "̤ޤȤƥȤɽ")
    ,(p (ptitle "층 (cont'd)")
        (center
         (html:img :src "http://schemearts.com/images/lisp-seminar-img1.png")))
    
    ;;                     Web
    ;;   
    ;;
    ;;   (󥸥)         XML     ɽ
    ;;
    ;;         Ϣ۸
    ;;                     text
    ,(p (ptitle "а")
        (d36
         (c1 "2005/8Ⱦ")
         (ul (li "MSIĻꥹ塼ǿ"
                 "(ץ̤)"))
         (c1 "2005/9")
         (ul (li "ץȹʤꤳ (MSI)"))
         (c1 "2005/10/")
         (ul (li "NIMSץ "))
         (c1 "2005/11/")
         (ul (li "Ժȳ"))
         (c1 "2005/11/")
         (ul (li "NIMSץ "))))
    ,(p (ptitle "а (cont'd)")
        "11/4ȽƤ"
        (d36
         (ul (li "- Ծwiki")
             (li "- web층 (оݥȤ̤)")
             (li "- DB층 (եޥå̤)")
             (li "- ϢФȹʤꤳ߸ (̤)"))))
    ,(p (oshigoto 1 "ɤޤäƤʤȤ¿"
                  (d28 "(桼ɤ狼äƤʤ or ֤褭ˤϤ館)")))

    ,(p (ptitle "а (cont'd)")
        "褯狼ʤ"
        (ul (li (c2 " Ȥꤢץȥ (2w)")))
        (vs 20)
        (d42 "Ȥˤươʤͤ"))
    ,(p (ptitle "狼äƤ뤳")
        (d42
         (ul (li "webȤΥե˸ꤲ")
             (li "̤եåѡ"
                 (ul (li "(ʣڡˤ錄礢)")))
             (li "ʣȤ߹碌 (and/or)"))))
    ,(p (ptitle "Issues")
        (c1 "եࡢ̡")
        (ul (li "ХХ")
            (li "Ѥ뤫")
            (li ""))
        (c1 "̤֤äƤޤǤԤ")
        (ul (li "٤ΤΧ®줿ʤ")))
    ,(p (ptitle "ǽ˽񤤤")
        (ul (li "- task network")
            (li "- data source abstraction")
            (li "- html matcher & extractor")
            (li "- server by AllegroServe")))
    ,(p (oshigoto 2 "֥ܥȥॢåסܥץȥס"))
    ,(p (ptitle "Task network")
        (center
         (html:img :src "http://schemearts.com/images/lisp-seminar-img2.png")))
    ,(p (ptitle "Data source abstraction")
        "Classes:"
        (d36 (ul (li (tt "class data-source"))
                 (li (tt "class data-record"))))
        "Methods to specialize:"
        (d36 (ul (li (tt "search-keyword")
                     "&nbsp;&nbsp;DS, String -> [Record]")
                 (li (tt "create-search-network")
                     "&nbsp;&nbsp;DS, Q -> SearchNetwork"))))
    ,(p (ptitle "Search network")
        "Q:"
        (d36 (pre "(:and (:or \"A\" \"B\") \"C\" \"D\")"))
        "SN:  ;; naive"
        (d36 (pre "(#[intersection]
  (#[union] #[search \"A\"]
            #[search \"B\"])
  #[search \"C\"]
  #[search \"D\"])")))
    ,(p (ptitle "Search network (2)")
        "Q:"
        (d36 (pre "(:and (:or \"A\" \"B\") \"C\" \"D\")"))
        "SN:  ;; site supports OR"
        (d36 (pre "(#[intersection]
  #[search \"A\" or \"B\"]
  #[search \"C\"]
  #[search \"D\"])")))
    ,(p (ptitle "Search network (3)")
        "Q:"
        (d36 (pre "(:and (:or \"A\" \"B\") \"C\" \"D\")"))
        "SN:  ;; supports 2 term AND"
        (d36 (pre "(#[intersection]
  (#[union] #[search \"A\"]
            #[search \"B\"])
  #[search \"C\" and \"D\"])")))
    ,(p (ptitle "Data source abstraction (2)")
        (c1 "Common function")
        (d36
         (ul (li (tt "initiate-search")
                 "&nbsp;&nbsp; Q, [DS] -> [Task]")
             (vs 10)
             (li (tt "poll-search-status")
                 "&nbsp;&nbsp; [(DS . Task)] -> [Status]"))))
    ,(p (ptitle "Matcher & extractor")
        "HTMLSɽ (LHTML) Ф"
        "ѥޥå"
        (d36
         (ul (li (tt "lxml-pick")
                 "&nbsp;&nbsp; [Node], Path -> [Node]")
             (vs 10)
             (li (tt "lxml-get-attr")
                 "&nbsp;&nbsp; Node, Name -> Attr")
             (vs 10)
             (li (tt "lxml-textize")
                 "&nbsp;&nbsp; Node -> Text"))))
    ,(p (ptitle "Matcher & extractor (cont'd)")
        (d24
         (pre "
 (let* ((id/authors
         (lxml-pick1 
            (lxml-kids tab)
           '((:tr 0) (:td 2) :*text)))
        (tlink
          (lxml-pick1
            (lxml-kids tab) 
           '((:tr 1) :td :a)))
        (uri 
          (lxml-get-attr tlink :href))
        (title
          (lxml-textize (lxml-kids tlink)))
        (other
          (lxml-textize 
           (lxml-pick (lxml-kids tab)
                     '((:tr 1) :td :a)
                     :mode :after))))
    (re-let \"^\\\\[(\\\\d+)\\\\](.*)\"
          id/authors
          ((id 1) (authors 2))
      ...")))
    ,(p (oshigoto 3 "֤Ȥꤢꥹȡܥ"))
    ,(p (ptitle "ޥ륹ȡ#1  11/29")
        (ul (li "- 3 data sources")
            (li "- AllegroServe front end")
            (li "- ꤷ̤ɽ")
            (li "- package, defsystem"))
        (vs 20)
        (c1 "γǧ")
        (vs 20)
        (c1 "¥ǡ䤷ƥץȶ"))
    ,(p (ptitle "å")
        "ƱqueryʤƱ̤ΤϤ" (html:br)
        "̤û֤Ǥ" (html:br)
        (vs 10)
        " 򥭡ˤƸߤξ֤䤤碌"
        " (ݤʥå)"
        (vs 20)
        (c1 "(äƤߤƤ狼ä)"))
    ,(p (oshigoto 4 "ֲ­좪ܹȤ˽˰ܹԡ"))
    ,(p (ptitle "ޥ륹ȡ#2  1/9")
        (ul (li "õXML (data-sourceΤҤȤ)"
                (ul (li "ץǡ")
                    (li "ݡȡǥ")))
            (li "web data sourceɲ"))
        (vs 20)
        ;(c1 "")
        ;(ul (li "̤ (饹?)")
        ;    (li "ʸ"))
        )
    ,(p (ptitle "եɥХå 1/25")
        (ul (li "data-source򥫥ƥ경")
            (li "ƥǥ")
            (li "ɽΥڡ")
            (li "ƥȸ")
            (li "õ֥ǡ")
            (li "Ϣ۸ɲ")))
    ,(p (oshigoto 5 "֥եɥХåϤĤǤ٤"
                  (d28 "(桼ϻȤǤߤʤȥ᡼Ϥʤ)")
                  (d28 "(ޤǤ˥ġ·Ƥ)")))
    ,(p (ptitle "ޥ륹ȡ#3 2/5")
        (ul (li "Ϣ۸ɲ")
            (li "ǡ")
            (li "ϥեޥåAPI"
                (ul (li (d36 "(MSI¦ȤΥ󥿥ե)"))))))
    ,(p (ptitle "ž夲")
        (c1 "Ϣwiki")
        (ul (li "APIڥ졼ޥ˥奢")
            (li "issue tracking"))
        (c1 "Scheme Artsô Ǽ 2/16"))
    ,(p (ptitle "Gotchas")
        (ul (li "ʸɤμ谷")
            (li "ǡäȰ㤦")
            (li "оdbѹ")
            (li "mlisp vs alisp")))
    ,(p (oshigoto 6 "ưƤ餬¶"))
    ,(p (ptitle "֤ä")
        (c1 "⡼ (/ϥ磻) ̵")
        (ul (li "&nbsp;&nbsp;饤ȤȤ޾פMSI"))
        (c1 "Τʥʬ䤬")
        (ul (li "&nbsp;&nbsp;ĻGJ")))
    ,(p (vs 300)
        (center (d54 "?")))
    ))

(set! *title* "Lisp Seminar")
